#ifndef ACO_H
#define ACO_H
#include <device/robot.h>


#include <list>
using std::list;
#include <vector> 
 using std::vector;
//
class ACO
{
public:
	ACO(int nsize, vector<int> obs, int startpos, int endpos);

  int numberOfAnts; // number of ants
	int E ; //maximum trasport number
	int size ; // size x and size y
	double alpha; 
	double beta ;
	int Q ;
	float rho;
	int NumberOfGenerations;
	int q0;
	int t0;
	vector<int> obstacles;
	vector<list<int> > journeynodeslists; 
	vector<list<int> > overallbest;
	vector<int> solution;
	vector<int> finalSolution;

	int startPosition;
	int endPosition;

	double heuristic(int currentpos);
  bool IsObstacle(int pos);
  bool InJourneyNodeList(int ant, int pos);
  int calculatePij(int nnode,vector<float> npher,int nk);
  bool IsPermitted(int previousNode, int newNode);
	

  void ACOSolution(int nsize);
  vector<int> antACO();
  void optimize();
  bool IsDiagonal(int pos1,int pos2);
};
#endif
