#include <device/robot.h>
#include "iCubCrawl.h"

#include <math/Solver.h>

#define TIME_STEP 2

iCubCrawl *my_robot;

static void reset(void) 
{
  my_robot->reset();

  return;
}


/*
 * This is the main control loop function, it is called repeatedly by Webots 
 */
static int run(int ms) 
{    
  return my_robot->run(ms);
}

/*
 * This is the main program which sets up the reset and run function.        
 */
int main()
{
  Solver::setType("EULER");

  my_robot = new iCubCrawl(TIME_STEP);

  robot_live(reset); /* initialization */
  robot_run(run);    /* starts the controller */

  return 0;
}
